/*
 * FileSoundInput.cpp
 *
 *  Created on: 20 déc. 2023
 *      Author: fanch
 */

#include "FileSoundInput.h"
#include <cstring>
#include <cmath>
FileSoundInput::FileSoundInput(const std::string &path, unsigned int sc) {
	m_path = path;
	m_type = Type::FILE;
	SF_INFO info;
   memset(&info, 0, sizeof(SF_INFO));
	m_fd = sf_open(m_path.c_str(), SFM_READ, &info);
	if (!m_fd){
		throw "Erreur de lecture de fichier";
	}
	m_channels = info.channels;
	m_sample_rate = info.samplerate;
	m_sample_size = info.format;
	m_sample_count = sc;
	m_buffer = new LADSPA_Data[m_channels * sc];
	init(sc);
}
int icount = 0;
FileSoundInput::~FileSoundInput() {
	close();
}

LADSPA_Data* FileSoundInput::_next(LADSPA_Data* x) {
	sf_count_t len;

	len = sf_readf_float(m_fd, m_buffer, (sf_count_t)(m_sample_count*m_channels) );
	int j=0;
	for(int i=0; i<len; i++){
		int ch = i % m_channels;
		if(!ch){
			x[j] = m_buffer[j];
			j++;
		}
	}

	icount ++;
	//printf("len = %d\n", len);
	if(!len) return NULL;
	return x;
}

void FileSoundInput::close() {
	if(m_fd){
		sf_close(m_fd);
	}
}
